/*
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        28.05.2004
 Description:    Ansteuerung eines Block Device via FAT

	Die Daten fr das FAT kommen aus der Dokumentation

	Microsoft Extensible Initiative FAT32 File System Specification
	FAT: General Overview of on-Disk Format

	Version 1.03, December 6,2000
	
*/

//Block Size in Bytes
#define BlockSize			512

//Master Boot Record
#define MasterBootRecord	0

//Volume Boot Record location in Master Boot Record
#define VBR_Addr 			0x1C6

//Boot Sctor and BPB Structure (BPB = Bios Parameter Block)
#define BS_jmpBoot			0
#define BS_OEMName			3
#define BPB_BytesPerSec		11
#define BPB_SecPerClus		13
#define BPB_RsvdSecCnt		14
#define BPB_NumFATs			16
#define BPB_RootEntCnt		17
#define BPB_TotSec16		19
#define BPB_Media			21
#define	BPB_FATSz16			22
#define BPB_SecPerTrk		24
#define BPB_NumHeads		26
#define BPB_HiddSec			28
#define BPB_TotSec32		32

//FAT12 and FAT16 Structure Starting at Offset 36
#define BS_DrvNum			36
#define BS_Reserved1		37
#define BS_BootSig			38
#define BS_VolID			39
#define BS_VolLab			43
#define BS_FilSysType		54

//FAT32 Structure Starting at Offset 36
#define BPB_FatSz32			36
#define BPB_ExtFlags		40
#define BPB_FSVer			42
#define BPB_RootClus		44
#define BPB_FSInfo			48
#define BPB_BkBootSec		50
#define BPB_Reserved		52

#define FAT32_BS_DrvNum		64
#define FAT32_BS_Reserved1	65
#define FAT32_BS_BootSig	66
#define FAT32_BS_VolID		67
#define FAT32_BS_VolLab		71
#define FAT32_BS_FilSysType	82
//End of Boot Sctor and BPB Structure

//FAT 32Byte Directory Entry Structure
#define DIR_Name			0
#define DIR_Attr			11	
#define DIR_NTRes			12
#define DIR_CrtTimeTenth	13
#define DIR_CrtTime			14
#define DIR_CrtDate			16
#define DIR_LstAccDate		18
#define DIR_FstClusHI		20
#define DIR_WrtTime			22
#define DIR_WrtDate			24
#define DIR_FstClusLO		26
#define DIR_FileSize		28
//End of FAT 32Byte Directory Entry Structure

//File attributes
#define ATTR_READ_ONLY	0 		//Bit 0 gesetzt
#define ATTR_HIDDEN		1		//Bit 1 gesetzt
#define ATTR_SYSTEM		2		//Bit 2 gesetzt
#define ATTR_VOLUME_ID	3		//Bit 3 gesetzt
#define ATTR_DIRECTORY	4		//Bit 4 gesetzt
#define ATTR_ARCHIVE	5		//Bit 5 gesetzt
//End of File attributes
